//******************************************************************************
// light.h
//
// Andrew Skowronski, Copyright 1999
// andrew_skow@hotmail.com
// 
//******************************************************************************

#ifndef _LIGHT_H
#define _LIGHT_H

#include <d3drm.h>

// Represents a light in the scene
// Allows the light to be easily turned on and off

class CLight
{
public:
	CLight() ;
	~CLight() ;

	// Sets up the light in the scene
	// but doesn't turn it on yet
	HRESULT Init( D3DRMLIGHTTYPE in_Type,
		       float in_Brightness,
			   float in_xPos,
			   float in_yPos,
			   float in_zPos,
			   float in_xRot,
			   float in_yRot,
			   float in_zRot,
			   float in_RotAmount,
			   LPDIRECT3DRMFRAME3 in_pRelativeFrame,
			   LPDIRECT3DRM3 in_pDRM3 ) ;

	// Turn the light on or off
	HRESULT ToggleActive() ;

	// TODO:
	// HRESULT LightSwitch( BOOL ) ; // Set On or Off
	// HRESULT GetLight( LPDIRECT3DRMLIGHT * out_ppLight ) ;

private:
    LPDIRECT3DRMFRAME3 m_pLightFrame ;
    LPDIRECT3DRMLIGHT  m_pLight ;

	BOOL m_bActive ;
} ;


#endif