// tracefile.cpp
// Simple helper class for dumping debug output to a text file,
// Useful for debugging full screen applications
// Could be adapted to output to VC debug console instead of
// file, to Assert when ErrorTrace is called.

#include "3DPlugin.h"

CTraceOutput::CTraceOutput()
	: m_pFile( NULL )
{
}

CTraceOutput::~CTraceOutput()
{
	Term() ;
}

void CTraceOutput::Init()
{
	if ( m_pFile == NULL )
	{
		// Adapt the location as you see fit, could also go 
		// in the plugin directory for example....

		// use "a+" to append to existing file
		m_pFile = fopen( "C:\\temp\\vid_d3d.log", "w" ) ; 
	}
}

void CTraceOutput::Term()
{
	if ( m_pFile != NULL )
	{
		fclose( m_pFile ) ;
		m_pFile = NULL ;
	}
}

void CTraceOutput::Trace( char * in_pszMsg )
{
	if ( ( m_pFile != NULL ) && ( in_pszMsg != NULL ) )
	{
		fprintf( m_pFile, "%s\n", in_pszMsg ) ;
	}
}

void CTraceOutput::ErrorTrace( char * in_pszMsg )
{
	// Can be adapted to also assert...
	
	if ( ( m_pFile != NULL ) && ( in_pszMsg != NULL ) )
	{
		fprintf( m_pFile, "ERROR: %s\n", in_pszMsg ) ;
	}
}